// TodayOptionsDialog.h: interface for the CTodayOptionsDialog class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(TODAYOPTIONSDIALOG_H_)
#define TODAYOPTIONSDIALOG_H_

#include "TodayWindow.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CTodayOptionsDialog  
{
public:
	HWND m_hWnd;

	CTodayOptionsDialog();
	CTodayOptionsDialog(HINSTANCE hInstance, CTodayWindow *pToday, BOOL bFullScreen = TRUE);
	virtual ~CTodayOptionsDialog();

	// Get methods
	HINSTANCE GetInstance() {return m_hInstance;};
	BOOL GetFullScreen() {return m_bFullScreen;};
	int GetTitleHeight() {return m_nTitleHeight;};
	DWORD GetStyle();

	// Set methods
	void SetInstance(HINSTANCE hInstance) {m_hInstance = hInstance;};
	void SetFullScreen(BOOL bFullScreen) {m_bFullScreen = bFullScreen;};
	void SetTitle(LPCTSTR lpszTitle, BOOL bRefresh = FALSE);
	void SetTitle(UINT nID, BOOL bRefresh = FALSE);

	void RefreshWindow();

	virtual LRESULT CALLBACK TodayOptionsWndProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
protected :
	// Reference to Today plug-in window
	CTodayWindow *m_pWndTW;

	SHACTIVATEINFO m_sai;

	BOOL m_bFullScreen;
	int m_nTitleHeight;

	LPCTSTR m_lpszTitle;

	HINSTANCE m_hInstance;
	HFONT m_hTitleFont;

	// Methods for better work with controls
	HWND ItemHandleFromID(UINT nID);
	BOOL IsButtonChecked(UINT nID);
	void CheckButton(UINT nID, BOOL bCheck = TRUE);
	void CheckRadionButton(UINT nIDFirst, UINT nIDLast, UINT nIDToCheck);

	virtual void DrawDialogTitle(HDC hDC);
	virtual void GetDefaultTitleFont();

	// Message handlers
	virtual BOOL OnInitDialog(TODAYLISTITEM *ptli);
	virtual void OnDestroy();
	virtual void OnOK();
	virtual void OnCancel();
	virtual void OnPaint(HDC hDC);
	virtual void OnActivate(UINT nState, HWND hWndPrevious, BOOL bMinimized);
	virtual void OnCommand(UINT nID, UINT nNotifyCode, HWND hWndCtrl);
	virtual void OnSettingChange(UINT nFlags, LPCTSTR lpszSection);
	virtual LRESULT OnNotify(UINT nID, NMHDR* pNMHDR);
	virtual LRESULT OnMessage(UINT uMsg, WPARAM wParam, LPARAM lParam);
};

#endif
